rawset(_G, "waytoofast", {})

waytoofast.cv_speedmod = CV_RegisterVar({"speedmod", "50", CV_NETVAR, {MIN=0, MAX=200}})
waytoofast.cv_fidelity = CV_RegisterVar({"fidelity", "4", CV_NETVAR, {MIN=1, MAX=32}})
waytoofast.mult = 0

addHook("NetVars", function(nv)
	waytoofast.mult = nv(waytoofast.mult)
end)

local function speedUp(mobj)
	if waytoofast.cv_speedmod.value == 0 then return end
	local addx = mobj.momx / waytoofast.cv_fidelity.value
	local addy = mobj.momy / waytoofast.cv_fidelity.value
	local partx = FixedMul(addx, waytoofast.mult)
	local party = FixedMul(addy, waytoofast.mult)
	for a=1,waytoofast.cv_fidelity.value do
		P_TryMove(mobj, (mobj.x + partx), (mobj.y + party), mobj.z, false)
	end
	if P_IsObjectOnGround(mobj)
		mobj.z = mobj.floorz
	end
end

local itemtypes = {MT_EGGMANITEM, MT_EGGMANITEM_SHIELD, MT_BANANA, MT_BANANA_SHIELD, MT_ORBINAUT, MT_ORBINAUT_SHIELD, MT_JAWZ, MT_JAWZ_DUD, MT_JAWZ_SHIELD,
	MT_SSMINE_SHIELD, MT_SSMINE, MT_BALLHOG, MT_BALLHOGBOOM, MT_SPB, MT_THUNDERSHIELD, MT_SINK, MT_SINK_SHIELD, MT_SINKTRAIL}

for mt = 1,#itemtypes do
	addHook("MobjThinker", speedUp, itemtypes[mt])
end

addHook("ThinkFrame", do
	if waytoofast.cv_speedmod.value == 0 then return end
	waytoofast.mult = (waytoofast.cv_speedmod.value) * FRACUNIT
	waytoofast.mult = $1 / 100
	for p in players.iterate
		if p.mo ~= nil
			speedUp(p.mo)
		end
	end
end)