-- Created by GenericHeroGuy for Sunflower's Garden
freeslot("SPR_SIGO")
mobjinfo[MT_OVERLAY].dispoffset = 3

local cv_minpos = CV_RegisterVar({
	name = "signs_minpos",
	defaultvalue = "3",
	flags = CV_NETVAR,
	possiblevalue = { MIN = 1, MAX = #players }
})

local top3colors = { SKINCOLOR_GOLD, SKINCOLOR_SILVER, SKINCOLOR_ROSEWOOD }
local cv_top3colors = CV_RegisterVar({
	name = "signs_top3", -- colorize_ballhogs conflict
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
})

local cv_flashintens = CV_RegisterVar({
	name = "signs_flashintensity",
	defaultvalue = "1",
	possiblevalue = { On = 1, Half = 2, Off = 3 }
})

local starttime, skyboxmo, camera, realmo, numstarposts = 6*TICRATE + (3*TICRATE/4), {}

-- hardcoded sign scales
local fixedscales = {
	[1] = 3*FRACUNIT/2,
	[2] = 5*FRACUNIT/4,
	[3] = 5*FRACUNIT/4,
}

--[[
COM_AddCommand("checkpoint", function() for p in players.iterate do p.starpostnum = numstarposts end end)
COM_AddCommand("item", function(p, item) p.kartstuff[k_itemtype] = tonumber(item); p.kartstuff[k_itemamount] = 1 end)
COM_AddCommand("dropsigns", function()
	for mapthing in mapthings.iterate do
		if mapthing.type == 501 then
			local sign = mapthing.mobj
			sign.movefactor = sign.z
			sign.target = players[0].mo
			sign.state = S_SIGN1
			sign.movecount = 1
			sign.z = $ + 768*mapobjectscale
		end
	end
end)
--]]


local function P_AltFlip(n, tics, slow)
	slow = slow or 1

	if (leveltime/slow) % (2 * tics) < tics then
		return n
	end

	return -n
end

local function P_LerpFlip(n, tics, slow)
	slow = slow or 1

	local w = 2 * tics

	return P_AltFlip((((leveltime/slow) % w) - tics) * n, w, slow)
end

addHook("NetVars", function(sync)
	numstarposts = sync($)
	skyboxmo = sync($)
end)

addHook("MapLoad", function()
	-- count the number of checkpoints
	-- yes this is ripped straight out of elim, should probably add a finish line hook in libsg or something
	local checkpoints = {}
	skyboxmo = {}
	for mapthing in mapthings.iterate do
		if mapthing.type == 502 then
			checkpoints[mapthing.angle/360] = true
		end
		-- oh and find the skybox mobj
		if mapthing.type == 780 then
			if mapthing.options & MTF_OBJECTSPECIAL then
				skyboxmo[1] = mapthing.mobj
			else
				skyboxmo[0] = mapthing.mobj
			end
		end
	end
	numstarposts = 0
	for _ in pairs(checkpoints) do
		numstarposts = $ + 1
	end
end)

local function ChangeFace(mo)
	local st = mo.signstuff
	local pmo = mo.target
	if st.facestop then return end

	if st.angleadd < ANG15 then -- don't change after last spin
		st.facestop = true
	end

	if not st.facestop then -- if we've stopped, always show the winner's face
		local mobjs = {}
		-- find all players who haven't finished
		for p in players.iterate do
			if not (p.spectator or p.exiting) then table.insert(mobjs, p.mo) end
		end
		-- pick a random player, except the winner or the last player shown
		while (pmo == mo.target or pmo == st.face.target) and #mobjs > 0 do
			local k = P_RandomRange(1, #mobjs)
			pmo = mobjs[k]
			table.remove(mobjs, k)
		end
		-- if there are no suitable targets, pmo will stay the same (i.e. show winner)
	end

	if pmo then
		st.face.target = pmo
		st.face.scale = mo.scale
		st.face.color = pmo.player.skincolor
		st.face.skin = pmo.skin
		st.face.localskin = pmo.localskin or pmo.skin
		-- Appearance support
		if pmo.player.appearance and pmo.player.appearance[pmo.skin] then
			st.face.sprite = APPEAR_Skins[pmo.skin][pmo.player.appearance[pmo.skin]]
		else
			st.face.sprite = pmo.sprite
		end

		local color, frame = ColorOpposite(pmo.player.skincolor)
		st.backdrop.color, st.backdrop.frame = color, FF_PAPERSPRITE|frame
	else -- :/
		st.face.target = nil
		st.face.sprite = SPR_SIGO
		st.face.frame = FF_PAPERSPRITE|S
		st.face.scale = mo.scale/3
	end
end

local function SpawnSparkleTrailLua(mo)-- same as the normal one but uses non synched rng
    local rad = (mo.radius*2)>>FRACBITS
    local sparkle
    local i

    for i = 0, 1 do

        local newx = mo.x - mo.momx + (N_RandomRange(-rad, rad)<<FRACBITS)
        local newy = mo.y - mo.momy + (N_RandomRange(-rad, rad)<<FRACBITS)
        local newz = mo.z - mo.momz + (N_RandomRange(0, mo.height>>FRACBITS)<<FRACBITS)

        sparkle = P_SpawnMobj(newx, newy, newz, MT_SPARKLETRAIL)
        --K_FlipFromObject(sparkle, mo)
        sparkle.eflags = (sparkle.eflags & ~MFE_VERTICALFLIP)|(mo.eflags & MFE_VERTICALFLIP)
        sparkle.flags2 = (sparkle.flags2 & ~MF2_OBJECTFLIP)|(mo.flags2 & MF2_OBJECTFLIP)

        if (sparkle.eflags & MFE_VERTICALFLIP) then
            sparkle.z = $ + mo.height - FixedMul(mo.scale, sparkle.height)
        end
        
        --P_SetTarget(&sparkle->target, mo)
        sparkle.destscale = mo.destscale
        sparkle.scale = mo.scale
        sparkle.color = mo.color
        --//sparkle->colorized = mo->colorized
    end
    sparkle.state =  S_KARTINVULN_LARGE1
end

addHook("ThinkFrame", function()
	if leveltime == 0 then return end
	for p in players.iterate do
		-- grab the player's mobj for first-person camera
		-- can't do this in a HUD hook because, y'know...
		if p == displayplayers[0] then
			local oldspec = p.spectator
			p.spectator = false
			realmo = p.mo
			p.spectator = oldspec
		end

		-- detect if the player finished the race
		if not p.spectator and p.exiting and p.starposttime == leveltime - starttime and P_PlayerTouchingSectorSpecial(p, 4, 10) then
			if p.kartstuff[k_position] == 1 then
				-- hardcode will spawn the sign for us
			elseif p.kartstuff[k_position] <= cv_minpos.value then
				local sign = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z + (768*mapobjectscale), MT_SIGN)
				sign.target = p.mo
				sign.state = S_SIGN1
				sign.movefactor = p.mo.floorz
				sign.movecount = 1
			end
		end
	end
end)

addHook("MobjSpawn", function(mo)
	-- i'll be taking over from here...
	mo.flags = $ | MF_SCENERY | MF_SPECIAL
end, MT_SIGN)

addHook("MobjThinker", function(mo)
	if not (mo.flags & MF_SCENERY) then
		print("That sign is a spy!")
		mo.tics = 1
		return
	end

	if not mo.signstuff then mo.signstuff = {} end
	local st = mo.signstuff

	if mo.movecount and not st.border then
		-- initialization time
		-- state doesn't matter as long as it's not S_INVISIBLE
		-- because hardcode checks for the sign's spawnstate to determine if it's activated
		local ks = mo.target.player.kartstuff
		local color = SKINCOLOR_GREY
		local nump = 0

		if ks[k_position] <= #fixedscales then
			mo.scale = FixedMul(fixedscales[ks[k_position]], mapobjectscale)
		else
			-- 1.25 - ((position - 1) * (1.0/signs_minpos)/2)
			-- size reduction is smaller the more signs there are
			mo.scale = $ + mapobjectscale/4 - (ks[k_position]-1) * (mapobjectscale/cv_minpos.value)/2
		end

		for p in players.iterate do if not p.spectator then nump = $ + 1 end end
		if cv_top3colors.value and cv_minpos.value > 1 and nump > 1 then
			color = top3colors[ks[k_position]] or $
		end
		if ks[k_growshrinktimer] > 0 then
			st.grow = true
			color = SKINCOLOR_BLUE
			mo.scale = FixedMul($, 4*FRACUNIT/3) -- 1.33x
		end

		mo.state = S_UNKNOWN
		mo.sprite = SPR_SIGO
		mo.color = color
		mo.frame = FF_PAPERSPRITE|Q
		st.angle = 0
		st.touchtimer = 0 -- for TouchSpecial effects
		st.invinc = ks[k_invincibilitytimer] > 0
		st.hyudoro = ks[k_hyudorotimer] > 0

		-- P_SpawnShadowMobj doesn't return the mobj spawned so
		st.shadow = P_SpawnMobj(mo.x, mo.y, mo.movefactor, MT_SHADOW)
		st.shadow.target = mo

		-- sign border
		local mo2 = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
		mo2.flags = $ | MF_NOTHINK
		mo2.scale = mo.scale
		mo2.state = S_UNKNOWN
		mo2.sprite = SPR_SIGO
		mo2.color = color
		mo2.frame = FF_PAPERSPRITE|R
		st.border = mo2

		-- backdrop (ColorOpposite)
		mo2 = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
		mo2.flags = $ | MF_NOTHINK
		mo2.scale = mo.scale
		mo2.state = S_UNKNOWN
		mo2.sprite = SPR_SIGO
		mo2.color = color
		st.backdrop = mo2

		-- player sign sprite
		mo2 = P_SpawnMobj(mo.x, mo.y, mo.z + 24*mo.scale, MT_OVERLAY)
		mo2.flags = $ | MF_NOTHINK
		mo2.scale = mo.scale
		mo2.state = mo.info.seestate
		mo2.frame = $ | FF_PAPERSPRITE
		st.face = mo2
	end

	local border, backdrop, face = st.border, st.backdrop, st.face

	if mo.movecount then
		if mo.z + mo.momz <= mo.movefactor then -- landing?
			if st.grow then
				S_StartSound(mo, sfx_s269) -- nice
				for dp in displayplayers.iterate do
					if dp.exiting then
						P_StartQuake(16*mapobjectscale, TICRATE/5)
						break
					end
				end
				for i = 1, 5 do
					local dust = P_SpawnMobj(mo.x, mo.y, mo.z, MT_DRIFTDUST)
					dust.momx = P_SignedRandom()*mapobjectscale/32
					dust.momy = P_SignedRandom()*mapobjectscale/32
					dust.momz = abs(P_SignedRandom()*mapobjectscale/64)
				end
			elseif mo.info.attacksound then
				S_StartSound(mo, mo.info.attacksound)
			end

			-- make it easier to hit after landing
			mo.radius = 24*mo.scale
			mo.height = 48*mo.scale
			P_RemoveMobj(st.shadow)

			mo.flags = $ | MF_NOGRAVITY
			mo.momz = 0
			mo.z = mo.movefactor
			mo.movecount = 0
		else -- still in the air
			P_SpawnMobj(mo.x + (P_RandomRange(-48,48)*mo.scale), mo.y + (P_RandomRange(-48,48)*mo.scale), mo.z + (24*mo.scale) + (P_RandomRange(-8,8)*mo.scale), MT_SIGNSPARKLE)
			mo.flags = $ & ~MF_NOGRAVITY
			if abs(mo.z - mo.movefactor) <= 512*mapobjectscale and not mo.cvmem then
				if mo.info.seesound then S_StartSound(mo, mo.info.seesound) end
				mo.cvmem = 1
			end
			st.angleadd = ANGLE_45
		end
	end

	if border then -- sign is visible?
		if st.angleadd then
			st.angle = $ + st.angleadd
			-- stop spinning only when angle is 0 degrees
			-- otherwise it may stop spinning while facing away from the camera
			if not (mo.movecount or st.angle or st.touchtimer) then st.stop = true end

			if st.stop then st.angleadd = max(0, $ - ANG1) end

			-- change face each time the sign spins 180 degrees
			if st.angle < 0 and st.revolution then
				st.revolution = false
				ChangeFace(mo)
			elseif st.angle >= 0 and not st.revolution then
				st.revolution = true
				ChangeFace(mo)
			end
		end
		st.touchtimer = max($ - 1, 0)

		local thiscam = camera

		-- if the sign is visible to the skybox viewpoint, assume the sign is in the skybox
		if skyboxmo[0] and P_CheckSight(skyboxmo[0], mo) then
			thiscam = { x = skyboxmo[0].x, y = skyboxmo[0].y }
			if skyboxmo[1] then -- oh dear... more hardcode incoming...
				local mh, x, y = mapheaderinfo[gamemap]
				if mh.skybox_scalex > 0 then
					x = (camera.x - skyboxmo[1].x) / mh.skybox_scalex
				elseif mh.skybox_scalex < 0 then
					x = (camera.x - skyboxmo[1].x) * -mh.skybox_scalex
				end

				if mh.skybox_scaley > 0 then
					y = (camera.y - skyboxmo[1].y) / mh.skybox_scaley
				elseif mh.skybox_scaley < 0 then
					y = (camera.y - skyboxmo[1].y) * -mh.skybox_scaley
				end

				local ang = skyboxmo[0].angle
				thiscam.x = $ + FixedMul(x, cos(ang)) - FixedMul(y, sin(ang))
				thiscam.y = $ + FixedMul(x, sin(ang)) + FixedMul(y, cos(ang))
			end
		end

		local screenangle = thiscam and R_PointToAngle2(thiscam.x, thiscam.y, mo.x, mo.y) or 0
		mo.angle = screenangle + ANGLE_90

		local ang = st.angle + screenangle
		border.angle, face.angle, backdrop.angle = ang, ang, ang
		border.z, backdrop.z, face.z = mo.z + mo.momz, mo.z + mo.momz, mo.z + mo.momz + 24*mo.scale

		-- invincibility effects
		if st.invinc then
			local invc
			if cv_flashintens.value == 1 then
				invc = 1 + (leveltime % (MAXSKINCOLORS-1))
			elseif cv_flashintens.value == 2 then
				invc = 1 + (leveltime/2 % (MAXSKINCOLORS-1))
			end

			if cv_flashintens.value ~= 3 then
				mo.color, border.color = invc, invc
				face.color = invc
				face.colorized = true
			end

			border.momz = 8*mapobjectscale -- momz is added to sparkle z
			border.radius = 24*mapobjectscale
			if cv_flashintens.value == 1 or (cv_flashintens.value == 2 and (leveltime % 2 == 0)) then
				SpawnSparkleTrailLua(border)
			end
			border.momz = 0
        end

        if st.hyudoro then
			local trans = (P_LerpFlip(1, 2, 5) + 6)*FF_TRANS10

			face.frame = ($ & ~FF_TRANSMASK) | trans
        end
	end
end, MT_SIGN)


-- make the sign spin if you touch it
addHook("TouchSpecial", function(mo, pmo)
	local st = mo.signstuff
	if not (st.border and pmo.player.speed > 8*mapobjectscale)
	or (mo.movecount and st.touchtimer) or (not mo.movecount and st.angleadd) then return true end

	if mo.info.seesound then S_StartSound(mo, mo.info.seesound) end
	if mo.movecount then
		mo.momz = min(pmo.player.speed / 6, 10*mapobjectscale)
--		print(mo.momz)
	else
		st.angle = $ & 0xE0000000 -- only 45-degree increments, else it never stops
		st.angleadd = ANGLE_45
		st.stop = false
	end

	st.touchtimer = pmo.player.speed / (32*mapobjectscale/TICRATE)
	return true
end, MT_SIGN)

hud.add(function(_, p, c)
	if c.pnum == 1 then
		if p.awayviewtics then
			camera = { x = p.awayviewmobj.x, y = p.awayviewmobj.y }
		elseif (p.spectator or CV_FindVar("chasecam").value == 0) and not p.exiting and realmo and realmo.valid then
			camera = { x = realmo.x, y = realmo.y }
		else
			camera = { x = c.x, y = c.y }
		end
	end
end)
