local cv_growcanceltime = CV_RegisterVar {
    name = "growcanceltime",
    defaultvalue = "17",
    possiblevalue = CV_Unsigned,
    flags = CV_NETVAR,
}

local REALGROWCANCELMAX = 26

local function getRealGrowCancel(fake)
    return FixedMul(FixedDiv(fake<<FRACBITS, cv_growcanceltime.value<<FRACBITS), REALGROWCANCELMAX<<FRACBITS)>>FRACBITS
end

addHook("PlayerThink", function(p)
    if cv_growcanceltime.value == 0 then return end
    if p.spectator then return end

    local ks = p.kartstuff

    if (p.cmd.buttons & BT_ATTACK) and ks[k_growshrinktimer] > 0 and ks[k_growcancel] >= 0 then
        p.growcancel = ($ or 0) + 1

        -- Just in case
        local realgrowcancel = min(getRealGrowCancel(p.growcancel), REALGROWCANCELMAX-1)

        if p.growcancel > cv_growcanceltime.value then
            realgrowcancel = REALGROWCANCELMAX
        end

        ks[k_growcancel] = realgrowcancel
    else
        p.growcancel = 0
    end
end)
