-- Toggle neoroulette off when in low player lobby
local cv_enabled = CV_RegisterVar {
    name = "nra_enabled",
    defaultvalue = "On",
    possiblevalue = CV_OnOff,
    flags = CV_NETVAR, -- Not necessary but will not make any sense to allow that be modified by non-server players
}

local cv_minplayers = CV_RegisterVar {
    name = "nra_minplayers",
    defaultvalue = "7",
    possiblevalue = CV_Natural,
    flags = CV_NETVAR, -- Not necessary but will not make any sense to allow that be modified by non-server players
}

local vanilla = false
local cumbi = nil
local reason = nil -- Used for message

local function shouldUseVanillaRoulette()
    local numplayers = 0

    for p in players.iterate do
        if not p.spectator then numplayers = $ + 1 end
    end

    if numplayers < cv_minplayers.value then
        reason = "Bellow "..cv_minplayers.string.." players"
        return true
    end

    if cumbi and cumbi.value then
        reason = "Combi is active"
        return true
    end

    return false
end

addHook("NetVars", function(net)
    vanilla = net($)
end)

addHook("ThinkFrame", function()
    --if not isserver then return end
    if cv_enabled.value == 0 then return end

    if not cumbi then cumbi = CV_FindVar("combi_active") end

    local should_vanilla = shouldUseVanillaRoulette()

    if not vanilla and should_vanilla then
        vanilla = true

        COM_BufInsertText(server, "nr_enabled Off")
        print("\131Neoroulette: \128"..reason..", vanilla item odds & calculations active.")
        return
    end

    if vanilla and not should_vanilla then
        vanilla = false

        COM_BufInsertText(server, "nr_enabled On")
        print("\131Neoroulette: \128Sunflower's item odds & calculations active.")
    end
end)
